'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HMR_NOT_SUPPORTED = void 0;

if (process.env.NODE_ENV === 'development') {
  HMR_NOT_SUPPORTED = '\n================================================================================\nERROR: code-split-component\n\nSorry, unfortunately code-split-component does not support hot module reloading.\n\nIf you wish to use it in a hot relaoading environment please set the \'disabled\'\noption on both the babel and webpack plugins to true.  This will force the\ncode-split-component instances to work in a synchronous manner that is friendlier\nto development and hot reloading environments.  Code splitting is a production\nbased optimisation, so hopefully this is not an issue for you.\n\ne.g.\n\nconst webpackConfig = {\n  plugins: [\n    new CodeSplitWebpackPlugin({\n      // The code-split-component doesn\'t work nicely with hot module reloading,\n      // which we use in our development builds, so we will disable it (which\n      // ensures synchronously behaviour on the CodeSplit instances).\n      disabled: process.env.NODE_ENV === \'development\',\n    }),\n  ],\n  module: {\n    rules: [\n      {\n        test: \'js\',\n        loader: \'babel\',\n        query: {\n          plugins: [\n            [\n              \'code-split-component/babel\',\n              {\n                // The code-split-component doesn\'t work nicely with hot\n                // module reloading, which we use in our development builds,\n                // so we will disable it (which ensures synchronously\n                // behaviour on the CodeSplit instances).\n                disabled: process.env.NODE_ENV === \'development\',\n              },\n            ],\n          ]\n        }\n      }\n\n    ]\n  }\n}\n\n================================================================================';
} else {
  HMR_NOT_SUPPORTED = 'HMR not supported for code-split-component';
}

var es6Safe = function es6Safe(module) {
  return module.default ? module.default : module;
};
var ensureES6Safe = function ensureES6Safe(x) {
  return function () {
    var result = x();
    Object.keys(result).forEach(function (key) {
      result[key] = es6Safe(result[key]);
    });
    return result;
  };
};

var CodeSplit = function (_Component) {
  _inherits(CodeSplit, _Component);

  function CodeSplit() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CodeSplit);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CodeSplit.__proto__ || Object.getPrototypeOf(CodeSplit)).call.apply(_ref, [this].concat(args))), _this), _this.state = { resolving: false }, _this.resolutionCallback = function (resolved) {
      var _this$props = _this.props,
          chunkName = _this$props.chunkName,
          moduleMap = _this$props.moduleMap;
      var _this$context = _this.context,
          registerChunkLoaded = _this$context.registerChunkLoaded,
          registerModule = _this$context.registerModule;

      registerChunkLoaded(chunkName);
      Object.keys(resolved).forEach(function (moduleName) {
        return registerModule(moduleMap[moduleName], // id
        resolved[moduleName] // module
        );
      });
      _this.setState({ resolving: false });
    }, _this.getModules = ensureES6Safe(function () {
      var modules = _this.props.modules;

      if ((typeof modules === 'undefined' ? 'undefined' : _typeof(modules)) === 'object') {
        // Sync modules.
        return modules;
      }
      // Async modules, retrieve from registry.
      var moduleMap = _this.props.moduleMap;
      var retrieveModule = _this.context.retrieveModule;

      var moduleNames = Object.keys(moduleMap);
      return moduleNames.reduce(function (acc, moduleName) {
        var moduleId = moduleMap[moduleName];
        var module = retrieveModule(moduleId);
        if (module) {
          acc[moduleName] = module; // eslint-disable-line no-param-reassign
        }
        return acc;
      }, {});
    }), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CodeSplit, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          modules = _props.modules,
          moduleMap = _props.moduleMap;

      if (typeof modules === 'function') {
        if (module.hot) {
          throw new Error(HMR_NOT_SUPPORTED);
        }

        // Async modules.
        var alreadyResolved = Object.keys(moduleMap).length === Object.keys(this.getModules()).length;
        if (!alreadyResolved) {
          // Not all the modules have been resolved yet.
          this.setState({ resolving: true });
          // Fire the fetch modules function.
          modules(this.resolutionCallback);
        }
      } else if (moduleMap) {
        // Sync modules.
        // We have a module map available. This probably means an SSR render is
        // occurring, so lets register these modules.
        this.resolutionCallback(modules);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(this.getModules()) || null;
    }
  }]);

  return CodeSplit;
}(_react.Component);

CodeSplit.contextTypes = {
  registerChunkLoaded: _react.PropTypes.func.isRequired,
  registerModule: _react.PropTypes.func.isRequired,
  retrieveModule: _react.PropTypes.func.isRequired
};
CodeSplit.propTypes = {
  chunkName: _react.PropTypes.string.isRequired,
  moduleMap: _react.PropTypes.object, // eslint-disable-line react/forbid-prop-types
  modules: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.object]).isRequired,
  children: _react.PropTypes.func.isRequired
};
exports.default = CodeSplit;