'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stateIdentifier = require('./stateIdentifier');

var _stateIdentifier2 = _interopRequireDefault(_stateIdentifier);

var _chunkNameHash = require('./utils/chunkNameHash');

var _chunkNameHash2 = _interopRequireDefault(_chunkNameHash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-undef */
/* eslint-disable no-console */

function logError(err) {
  console.log('An error occurred whilst attempting to rehydrate code-split-component.', err, err.stack);
}

function rehydrate() {
  if (!__webpack_require__) {
    console.log('code-split-component rehydration requires that your source is bundled with webpack.');
  }

  return new Promise(function (resolve) {
    if (!window || !window[_stateIdentifier2.default]) {
      resolve();
      return;
    }

    var _window$STATE_IDENTIF = window[_stateIdentifier2.default],
        chunks = _window$STATE_IDENTIF.chunks,
        modules = _window$STATE_IDENTIF.modules;


    Promise.all(chunks.map(function (chunkName) {
      return __webpack_require__.e((0, _chunkNameHash2.default)(chunkName));
    })).then(function () {
      return modules.map(function (moduleId) {
        return {
          id: moduleId,
          module: __webpack_require__(moduleId)
        };
      });
    }).then(resolve).catch(logError);
  });
}

exports.default = rehydrate;